package info.edu.operation;

import info.edu.BaseMain;
import info.edu.model.User;
import info.edu.service.UserService;
import info.edu.utils.Regular;

import javax.annotation.processing.SupportedSourceVersion;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.List;

public class HomeOperation extends BaseMain {

    private UserService userService = new UserService();


    public void home(){
        System.out.println("\033[33;4m" + "Welcome to use SuperManager Login Success" + "\033[0m"+"\n\n");
        System.out.println("\033[34;4m" + "1,与我相关" + "\033[0m");
        System.out.println("\033[35;4m" + "2,商品管理" + "\033[0m");
        System.out.println("\033[37;4m" + "3,退出系统" + "\033[0m");

        System.out.print("\033[38;4m" + "请输入要进行的操作:" + "\033[0m");
        operation();
    }

    public static void main(String[] args){
        HomeOperation homeOperation = new HomeOperation();
        homeOperation.userlist();
    }

    public void userlist(){
        System.out.print("\033[34;4m" + "用户Id" + "\033[0m"+"\t\t\t\t\t\t\t\t");
        System.out.print("\033[35;4m" + "用户账号" + "\033[0m"+"\t\t\t\t\t");
        System.out.print("\033[36;4m" + "用户名称" + "\033[0m"+"\t\t\t\t\t");
        System.out.print("\033[37;4m" + "创建时间" + "\033[0m"+"\n");
        List<User> users = userService.getAllUser();
        if(users!=null){
            for (User user : users) {
                System.out.print("\033[34;4m" + user.getId() + "\033[0m"+"\t\t\t\t\t");
                System.out.print("\033[35;4m" + user.getAccount() + "\033[0m"+"\t\t\t\t\t");
                System.out.print("\033[36;4m" + user.getName()+ "\033[0m"+"\t\t\t\t\t");
                System.out.print("\033[37;4m" + user.getCreated() + "\033[0m"+"\n");
            }
        }
        System.out.println("\n"+"\033[34;4m" + "1,返回主页" + "\033[0m");
        System.out.println("\033[35;4m" + "2,删除用户" + "\033[0m");
        System.out.println("\033[38;4m" + "请输选择操作:" + "\033[0m");
        operationUser();
    }

    public void operationUser(){
        String operation = getInput();
        switch (operation){
            case "1":
                home();
                break;
            case "2":
                System.out.println("\033[38;4m" + "请输入要删除的Id:" + "\033[0m");
                delUser();
                break;
            default:
                System.out.println("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                operationUser();
                break;
        }
    }

    public void delUser() {
        String id = getInput();
        Integer del = userService.del(id);
        switch (del){
            case 0:
                System.out.println("\033[38;4m" + "删除成功!请选择操作:" + "\033[0m");
                delOpertion();
                break;
            case 1:
                System.out.println("\033[38;4m" + "删除用户不存在!请输选择操作:" + "\033[0m");
                delOpertion();
                break;
            default:
                System.out.println("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                delUser();
                break;
        }
    }

    public void delOpertion(){
        System.out.println("\033[35;4m" + "1,重新输入" + "\033[0m");
        System.out.println("\033[35;4m" + "2,返回列表" + "\033[0m");
        System.out.println("\033[35;4m" + "3,返回主页" + "\033[0m");
        System.out.println("\033[38;4m" + "请输选择操作:" + "\033[0m");
        operationDel();
    }

    public void operationDel(){
        String operation = getInput();
        switch (operation){
            case "1":
                delUser();
                break;
            case "2":
                userlist();
                break;
            case "3":
                home();
                break;
            default:
                System.out.println("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                operationDel();
                break;
        }
    }

    public void operation(){
        String operation = getInput();
        switch (operation){
            case "1":
                userlist();
                break;
            case "2":
                System.out.println("\033[38;4m" + "该功能暂未完善!请输选择其他操作:" + "\033[0m");
                operation();
                break;
            case "3":
                System.out.println("\033[33;4m" + "System Closed!" + "\033[0m"+"\n\n");
                Thread.interrupted();
                break;
            default:
                System.out.println("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                operation();
                break;
        }
    }

    public static String getInput(){
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        try {
            String perNumber = br.readLine();
            return perNumber;
        }catch (Exception e){
            System.out.print("\033[38;4m" + "Input Error ! System Closed" + "\033[0m");
            return null;
        }
    }


}
