package info.edu.operation;

import info.edu.BaseMain;
import info.edu.service.UserService;
import info.edu.utils.Regular;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class UserOperation extends BaseMain {

    private UserService userService = new UserService();

    private HomeOperation homeOperation = new HomeOperation();

    public void home(){
        System.out.println("\033[33;4m" + "Welcome to use SuperManager" + "\033[0m"+"\n\n");
        System.out.println("\033[34;4m" + "1,用户登陆" + "\033[0m");
        System.out.println("\033[35;4m" + "2,用户注册" + "\033[0m");
        System.out.println("\033[36;4m" + "3,密码找回" + "\033[0m");
        System.out.println("\033[37;4m" + "4,退出系统" + "\033[0m");

        System.out.print("\033[38;4m" + "请输入要进行的操作:" + "\033[0m");
        operation();

    }

    public void operation(){
        String operation = getInput();
        System.out.println(operation);
        switch (operation){
            case "1":
                userLogin();
                break;
            case "2":
                //执行注册
                userRegist();
                break;
            case "3":
                updatePwd();
                break;
            case "4":
                System.out.println("\033[33;4m" + "System Closed!" + "\033[0m"+"\n\n");
                Thread.interrupted();
                break;
            default:
                System.out.println("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                operation();
                break;
        }
    }

    public void updatePwd(){
        System.out.println("\033[33;4m" + "SuperManager User Update Password" + "\033[0m"+"\n\n");
        System.out.print("\033[34;4m" + "请输入账号：" + "\033[0m");
        String account = getUserAccount();
        isUser(account);
    }

    public void updatePwd(String account){
        System.out.println("\033[38;4m" + "请输入要修改的密码:" + "\033[0m");
        String pwd = getPasswd();
        Integer update = userService.updatePwd(account,pwd);
        switch (update){
            case 0:
                System.out.println("\033[38;4m" + "密码修改成功!你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
            default:
                System.out.println("\033[38;4m" + "登陆错误!你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
        }
    }

    public void isUser(String account){
        Integer isUser = userService.getUser(account);
        switch (isUser){
            case 0:
                updatePwd(account);
                break;
            case 1:
                System.out.println("\033[38;4m" + "该账号不存在你可以进行如下操作:" + "\033[0m");
                userOperationRgist();
                break;
            default:
                System.out.println("\033[38;4m" + "登陆错误!你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
        }
    }

    public void userLogin(){
        System.out.println("\033[33;4m" + "SuperManager User Login" + "\033[0m"+"\n\n");
        System.out.print("\033[34;4m" + "请输入账号：" + "\033[0m");
        String account = getUserAccount();
        System.out.print("\033[34;4m" + "请输入密码：" + "\033[0m");
        String pwd = getPasswd();
        Integer retCode = userService.login(account,pwd);
        switch (retCode){
            case 0:
                System.out.println("\033[38;4m" + "登陆成功:" + "\033[0m");
                homeOperation.home();
                break;
            case 1:
                System.out.println("\033[38;4m" + "该账号未注册" + "\033[0m");
                userOperationRgist();
                break;
            case 2:
                System.out.println("\033[38;4m" + "账号或密码错误" + "\033[0m");
                userOperationSuccess();
                break;
            default:
                System.out.println("\033[38;4m" + "登陆错误!你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
        }
    }

    public void userRegist(){
        clearConsole();
        System.out.println("\033[33;4m" + "SuperManager User Regist" + "\033[0m"+"\n\n");
        System.out.print("\033[34;4m" + "请输入用户名 ：" + "\033[0m");
        String name = getInput();
        System.out.print("\033[34;4m" + "请输入用户账号（账号要求纯数字）：" + "\033[0m");
        String account = getUserAccount();
        System.out.print("\033[34;4m" + "请输入用户密码：" + "\033[0m");
        String pwd = getPasswd();
        Integer retCode = userService.save(account,pwd,name);
        switch (retCode){
            case 0:
                System.out.println("\033[38;4m" + "该账号已经注册！你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
            case 1:
                System.out.println("\033[38;4m" + "账号注册成功！你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
            default:
                System.out.println("\033[38;4m" + "账号注册失败!你可以进行以下操作:" + "\033[0m");
                userOperationSuccess();
                break;
        }
    }

    public void userOperationRgist(){
        System.out.println("\033[34;4m" + "1,返回首页" + "\033[0m");
        System.out.println("\033[35;4m" + "2,注册账号" + "\033[0m");
        operationRegist();
    }

    public void operationRegist() {
        String operation = getInput();
        System.out.println(operation);
        switch (operation) {
            case "1":
                home();
                break;
            case "2":
                userRegist();
                break;
            default:
                System.out.println("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                operationSuccess();
                break;
        }
    }

    public void userOperationSuccess(){
        System.out.println("\033[34;4m" + "1,返回首页" + "\033[0m");
        System.out.println("\033[35;4m" + "2,跳转登陆" + "\033[0m");
        operationSuccess();
    }
    public void operationSuccess(){
        String operation = getInput();
        System.out.println(operation);
        switch (operation){
            case "1":
                home();
                break;
            case "2":
                userLogin();
                break;
            default:
                System.out.print("\033[38;4m" + "操作非法!请输选择正确的操作:" + "\033[0m");
                operationSuccess();
                break;
        }
    }

    public String getPasswd(){
        String userPwd = getInput();
        if(Regular.passwdCheck(userPwd)){
            return userPwd;
        }else {
            System.out.print("\033[34;4m" + "非法输入（密码只能输入6-20个字母、数字、下划线）请重新输入：" + "\033[0m");
            getPasswd();
            return null;
        }

    }

    public String getUserAccount(){
        String userAccount = getInput();
        if(Regular.isNumericzidai(userAccount)){
            return userAccount;
        }else {
            System.out.print("\033[34;4m" + "非法输入（账号要求纯数字）请重新输入：" + "\033[0m");
            getUserAccount();
            return null;
        }
    }

    public static String getInput(){
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        try {
            String perNumber = br.readLine();
            return perNumber;
        }catch (Exception e){
            System.out.print("\033[38;4m" + "Input Error ! System Closed" + "\033[0m");
            return null;
        }
    }


    // 清空控制台
    private static void clearConsole()
    {
        try
        {
            String os = System.getProperty("os.name");

            if (os.contains("Windows"))
            {
                Runtime.getRuntime().exec("cls");
            }
            else
            {
                Runtime.getRuntime().exec("clear");
            }
        }
        catch (Exception exception)
        {
            //  Handle exception.
        }
    }
}
