package info.edu.service;

import info.edu.BaseMain;
import info.edu.model.Item;
import info.edu.model.User;
import info.edu.utils.IdGen;
import info.edu.utils.MD5Utils;
import info.edu.utils.XmlUtils;
import sun.security.provider.MD5;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class UserService extends XmlUtils<User> {

    private BaseMain baseMain = new BaseMain();

    public int save(String account,String pwd,String name){
        try{
            User user = new User();
            user.setId(IdGen.getId());
            user.setAccount(account);
            user.setName(name);
            user.setPwd(MD5Utils.pwdRule(pwd));
            user.setCreated(System.currentTimeMillis()+"");
            if (this.readInnerXmlByAccount(XMLFILES.USER.getPath(),account) != null){
                return  0;
            }
            this.writeInnerXml(XMLFILES.USER.getPath(),user);
            return 1;
        }catch (Exception e){
            System.out.println("System Error!");
            return -1;
        }

    }


    public int login(String account,String pwd){
        try{
            Map user = this.readInnerXmlByAccount(XMLFILES.USER.getPath(),account);
            if (user == null){
                return  1;
            }
            if(MD5Utils.pwdValidate(pwd,user.get("pwd").toString())){
                //写入BaseMain 方面操作端operation 全局调用
               baseMain.setToken(user);
                return 0;
            }else {
                return 2;
            }
        }catch (Exception e){
            System.out.println("System Error!");
            return -1;
        }

    }

    public int getUser(String account){
        try{
            Map user = this.readInnerXmlByAccount(XMLFILES.USER.getPath(),account);
            if (user == null){
                return  1;
            }else {
                return 0;
            }
        }catch (Exception e){
            System.out.println("System Error!");
            return -1;
        }
    }

    public int updatePwd(String account,String pwd){
        try{
            Map user = this.readInnerXmlByAccount(XMLFILES.USER.getPath(),account);
            User user2 = new User();
            user2.setPwd(MD5Utils.pwdRule(pwd));
            this.UpdateXml(XMLFILES.USER.getPath(),user.get("id").toString(),user2);
            return 0;
        }catch (Exception e){
            System.out.println("System Error!");
            return -1;
        }
    }

    public void update(String id ,String account,String pwd,String name) throws Exception{
        User user = new User();
        user.setId(id);
        user.setAccount(account);
        user.setName(name);
        user.setPwd(MD5Utils.pwdRule(pwd));
        user.setCreated(System.currentTimeMillis()+"");
        if (this.readInnerXmlById(XMLFILES.USER.getPath(),id.toString()) == null){
            System.out.println("制定修改账号不存在!");
            return;
        }
        this.writeInnerXml(XMLFILES.USER.getPath(),user);
        System.out.println("用户信息修改成功!");
    }

    public List<User> getAllUser() {
        try{
            return baseMain.getAllUser(this.readInnerXml(XMLFILES.USER.getPath()));
        }catch (Exception e){
            System.out.println("System Error!");
            return null;
        }
    }


    public int del(String id) {
        try {
            return this.DeleteXml(id,XMLFILES.USER.getPath());
        }catch (Exception e){
            return -1;
        }
    }
}
